diff -Nru t1lib-grace/T1lib/t1lib/t1base.c t1lib-deb/T1lib/t1lib/t1base.c
--- t1lib-grace/T1lib/t1lib/t1base.c	2004-04-13 13:27:44.000000000 -0700
+++ t1lib-deb/T1lib/t1lib/t1base.c	2007-12-23 07:49:42.000000000 -0800
@@ -1,11 +1,11 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1base.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-10-03
+  ----- Date:        2005-05-17
   ----- Description: This file is part of the t1-library. It contains basic
                      routines to initialize the data structures used
 		     by the t1-library.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2005.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -50,11 +50,12 @@
 
 #include "../type1/ffilest.h" 
 #include "../type1/types.h"
-#include "parseAFM.h" 
+#include "parseAFM.h"
 #include "../type1/objects.h"
 #include "../type1/spaces.h"
 #include "../type1/util.h"
 #include "../type1/fontfcn.h"
+#include "../type1/paths.h"
 #include "../type1/regions.h"
 
 
@@ -66,8 +67,66 @@
 #include "t1delete.h"
 
 
+static int test_for_t1_file( char *buffer );
 static int T1_pad=0;
 
+/* A fix for Encoding Vector problem. Initialization / Deinitialization
+   is now done in T1_InitLib() / T1-CloseLib. */
+extern boolean Init_BuiltInEncoding( void);
+extern psobj *StdEncArrayP;
+
+static const char* T1errmsg[] = {
+  "",                                                          /*                              -10 */
+  "",                                                          /*                              -9  */
+  "",                                                          /*                              -8  */
+  "",                                                          /*                              -7  */
+  "",                                                          /*                              -6  */
+  "Attempt to Load Multiple Master Font",                      /* T1ERR_SCAN_FONT_FORMAT       -5  */
+  "Type 1 Font File Open Error",                               /* T1ERR_SCAN_FILE_OPEN_ERR     -4  */
+  "Virtual Memory Exceeded",                                   /* T1ERR_SCAN_OUT_OF_MEMORY     -3  */
+  "Syntactical Error Scanning Font File",                      /* T1ERR_SCAN_ERROR             -2  */
+  "Premature End of Font File Encountered",                    /* T1ERR_SCAN_FILE_EOF          -1  */
+  "",                                                          /*                               0  */
+  "Path Construction Error",                                   /* T1ERR_PATH_ERROR              1  */
+  "Font is Corrupt",                                           /* T1ERR_PARSE_ERROR             2  */
+  "Rasterization Aborted",                                     /* T1ERR_TYPE1_ABORT             3  */
+  "",                                                          /*                               4  */
+  "",                                                          /*                               5  */
+  "",                                                          /*                               6  */
+  "",                                                          /*                               7  */
+  "",                                                          /*                               8  */
+  "",                                                          /*                               9  */
+  "Font ID Invalid in this Context",                           /* T1ERR_INVALID_FONTID          10 */
+  "Invalid Argument in Function Call",                         /* T1ERR_INVALID_PARAMETER       11 */
+  "Operation not Permitted",                                   /* T1ERR_OP_NOT_PERMITTED        12 */
+  "Memory Allocation Error",                                   /* T1ERR_ALLOC_MEM               13 */
+  "Error Opening File",                                        /* T1ERR_FILE_OPEN_ERR           14 */
+  "Unspecified T1Lib Error",                                   /* T1ERR_UNSPECIFIED             15 */
+  "Missing AFM Data",                                          /* T1ERR_NO_AFM_DATA             16 */
+  "X11 Interface Error",                                       /* T1ERR_X11                     17 */
+  "Missing Component of Composite Character"                   /* T1ERR_COMPOSITE_CHAR          18 */
+  "Error Scanning Encoding File",                              /* T1ERR_SCAN_ENCODING           19 */
+  "",                                                          /*                               20 */
+};
+
+
+/* T1_StrError(): Return an error message corresponding to the value of
+   t1err. */
+const char *T1_StrError( int t1err) 
+{
+  int errind;
+
+  errind = t1err + 10;
+
+  if ( errind < 0 )
+    errind = 0;
+  if ( errind > 29 )
+    errind = 0;
+  
+  return T1errmsg[errind];
+}
+
+
 
 /* This function is to be called by the user to initialize
    the font mechanism */
@@ -80,8 +139,12 @@
   char *logfilepath=NULL;
   char *envlogreq=NULL;
   int  usrforcelog=0;
-  
-  
+
+  /* Check against multiple initialization. */
+  if ( T1_Up != 0 ) {
+    T1_errno=T1ERR_OP_NOT_PERMITTED;
+    return NULL;
+  }
   
   /* Reset T1_errno */
   T1_errno=0;
@@ -223,7 +286,12 @@
 		   T1LOG_WARNING);
   }
   
-
+  /* Initialize builtin Standard Encoding */
+  if ( !(Init_BuiltInEncoding()) ) {
+      T1_PrintLog( "T1_InitLib()", "Unable initialize internal StandardEncoding!",
+		   T1LOG_ERROR);
+  }
+  
   /* Set the default encoding to the fonts' internal encoding */
   pFontBase->default_enc=NULL;
   
@@ -255,14 +323,31 @@
     if (result>-1)
       pFontBase->no_fonts+=result;
     i++;
-    
   }
-  if (result == 0){
+  if ( (result == 0) && (i != 0)){
     T1_PrintLog( "T1_InitLib()", "No fonts from Font Database File(s) found (T1_errno=%d)",
 		 T1LOG_ERROR, T1_errno);
     return(NULL);
   }
 
+  result=0;
+  /* Read XLFD fontdatabase(s) */
+  i=0;
+  while (T1_FDBXLFD_ptr[i]!=NULL) {
+    if ((result=intT1_scanFontDBaseXLFD(T1_FDBXLFD_ptr[i]))==-1){
+      T1_PrintLog( "T1_InitLib()", "Fatal error scanning XLFD Font Database File %s",
+		   T1LOG_WARNING, T1_FDB_ptr[i]);
+    }
+    if (result>-1)
+      pFontBase->no_fonts+=result;
+    i++;
+  }
+  if ( (result == 0) && (i != 0)){
+    T1_PrintLog( "T1_InitLib()", "No fonts from XLFD Font Database File(s) found (T1_errno=%d)",
+		 T1LOG_ERROR, T1_errno);
+    return(NULL);
+  }
+
   /* Initialize the no_fonts... values */
   pFontBase->no_fonts_ini=pFontBase->no_fonts;
   pFontBase->no_fonts_limit=pFontBase->no_fonts;
@@ -284,7 +369,7 @@
    - initializes an array that allows to acces these names by an
      index number, the font_ID
    - returns -1 on fatal error and the number of fonts located
-     successfullly
+     successfully
    */
 int intT1_scanFontDBase( char *filename)
 {
@@ -295,7 +380,6 @@
   int nofonts=0;
   FONTPRIVATE* fontarrayP=NULL;
   
-  
 #ifndef O_BINARY
 #  define O_BINARY 0x0
 #endif
@@ -408,13 +492,139 @@
 }
 
 
+/* intT1_scanFontDBaseXLFD():
+   - opens the file with the font definitions,
+   - reads the number of fonts defined and saves this in FontBase,
+   - allocates memory for all the filenames of the Type1 files
+   - tests for .pfa und .pfb files and saves the name found
+   - initializes an array that allows to acces these names by an
+     index number, the font_ID
+   - returns -1 on fatal error and the number of fonts located
+     successfully.
+
+     This function is identical to intT1_scanFontDBase() with the
+     difference that it expects the database file to be in XLFD format,
+     that is, the font's name comes in the first place stead of in
+     the last.
+   */
+int intT1_scanFontDBaseXLFD( char *filename)
+{
+  int fd;
+  int filesize, i, j, l, m;
+  int found=0, located=0;
+  char *filebuffer;
+  int nofonts=0;
+  FONTPRIVATE* fontarrayP=NULL;
+  
+#ifndef O_BINARY
+#  define O_BINARY 0x0
+#endif
+
+  if ((fd=open( filename, O_RDONLY | O_BINARY))<3){
+    T1_PrintLog( "intT1_scanFontDBaseXLFD()", "XLFD Font Database File %s not found!",
+		 T1LOG_WARNING, filename);
+    T1_errno=T1ERR_FILE_OPEN_ERR;
+    return(-1);
+  }
+
+  /* Get the file size */
+  filesize=lseek( fd, 0, 2);
+  /* Reset fileposition to start */
+  lseek (fd, 0, 0); 
+
+  if ((filebuffer=(char *)malloc(filesize*sizeof(char)
+				 )) == NULL){
+    T1_PrintLog(  "intT1_scanFontDBaseXLFD()",
+		  "Couldn't allocate memory for loading XLFD font database file %s",
+		  T1LOG_ERROR, filename);
+    T1_errno=T1ERR_ALLOC_MEM;
+    return(-1);
+  }
+  
+  i=read( fd, filebuffer, filesize);
+  close(fd);   /* Close XLFD font database file */
+   
+  i=j=l=m=0;
+  
+  while (i<filesize) {
+    if (filebuffer[i]=='\n'){ /* We are at the end of line */
+      if (j==0) {  /* Read the first line as the number of fonts */
+	filebuffer[i]=0;
+	sscanf( &filebuffer[0], "%d", &nofonts);
+	filebuffer[i]='\n';  /* Because it gives a better feeling */
+	/* (Re)Allocate memory for 'no_fonts' structures: */ 
+	if ((FontBase.pFontArray=(FONTPRIVATE *)
+	     realloc( FontBase.pFontArray, (FontBase.no_fonts+nofonts)*sizeof(FONTPRIVATE))) == NULL) {
+	  T1_PrintLog( "inT1_scanFontDBaseXLFD()",
+		       "Failed to allocate memory for FONTPRIVATE-area while scanning %s",
+		       T1LOG_ERROR, filename);
+	  T1_errno=T1ERR_ALLOC_MEM;
+	  return(-1);
+	}
+	/* setup pointer to newly allocated area and do a reset */
+	fontarrayP=&(FontBase.pFontArray[FontBase.no_fonts]);
+	memset(fontarrayP, 0, nofonts*sizeof(FONTPRIVATE));
+	located=1; /* In  order to increment m */
+      }
+      else {       /* We are in the second or higher line */
+	/* l indexes the beginning of the line */
+	while (isspace((int)filebuffer[l])){
+	  l++;
+	}
+	/* We are at the first printable character of a line; 
+	   scan the first white space terminated string as font
+	   file name. */
+	sscanf( &(filebuffer[l]), "%s", &(linebuf[0]));
+	/* We print error string before testing because after the call
+	   to test_for_t1_file() filename is substituted by an emty
+	   string if the file was not found: */
+	sprintf( err_warn_msg_buf, "Type 1 Font file %s.[pfa/pfb] not found (FontID=%d, SearchPath=%s)",
+		 linebuf, m-1, T1_GetFileSearchPath(T1_PFAB_PATH));
+	if ((test_for_t1_file( &linebuf[0]))){
+	  T1_PrintLog( "intT1_scanFontDBase()", err_warn_msg_buf, T1LOG_WARNING);
+	  located=0;
+	}
+	else{
+	  /* linebuf contains now the valid Type1 filename; let's
+	     now copy this string into the appropriate place in the
+	     FONTPRIVATE-struct: */
+	  found++;
+	  located=1;
+	  if ((fontarrayP[m-1].pFontFileName=(char *)
+	       calloc( strlen( &linebuf[0])+1, sizeof(char))) == NULL){
+	    T1_PrintLog( "intT1_scanFontDBaseXLFD()",
+			 "Failed to allocate memory for Filename %s (FontID=%d)",
+			 T1LOG_ERROR, &linebuf[0], m-1);
+	    T1_errno=T1ERR_ALLOC_MEM;
+	    return(-1);
+	  }
+	  strcpy( fontarrayP[m-1].pFontFileName, &linebuf[0]);
+	}
+      }
+      j++; /* Advance line counter */
+      if ((located))
+	m++;
+      /* Store index to new line */
+      l = i + 1;
+    }
+    if (j>nofonts) /* to ignore especially white space at end */
+      break;
+    i++;   /* Step further in file position */
+  }
+  /* Return the memory for file reading */
+  free(filebuffer); 
+  
+  return( found);
+}
+
+
 /* T1_CloseLib(): Close the library and free all associated memory */
 int T1_CloseLib( void)
 {
 
   int i, j, error=0;
 
-  if (T1_Up){
+  if ( T1_Up != 0 ) {
     for (i=pFontBase->no_fonts; i; i--){
       /* Free filename only if not NULL and if the font is physical!
 	 Do it before removing the font since the physical information
@@ -445,6 +655,12 @@
     else
       error=1;
 
+    /* Get rid of internal StandardEncoding vector */
+    if ( StdEncArrayP != NULL ) {
+      free( StdEncArrayP);
+      StdEncArrayP = NULL;
+    }
+
     /* Free search paths */
     intT1_FreeSearchPaths();
 
@@ -617,9 +833,9 @@
 
 
 
-/* CheckForInit(): If no initialization of font mechanism has been
+/* T1_CheckForInit(): If no initialization of font mechanism has been
    done, return -1, indicating an error. */
-int CheckForInit(void)
+int T1_CheckForInit(void)
 {
   if(T1_Up)
     return(0);
@@ -630,14 +846,14 @@
 
 
 
-/* CheckForFontID(): Checks the font mechanism concerning the specified
+/* T1_CheckForFontID(): Checks the font mechanism concerning the specified
    ID. It returns:
                    0  if font belonging to FontID has not yet been loaded
 		   1  if font belonging to FontID has already been loaded
 		   -1 if FontID is an invalid specification or t1lib not
 		      initialized
 		   */
-int CheckForFontID( int FontID)
+int T1_CheckForFontID( int FontID)
 {
 
   /* FontID is invalid */
@@ -656,7 +872,7 @@
 /* test_for_t1_file returns 0 if a file "name.pfa" or "name.pfb"
    was found. Else, -1 is returned. If successful, buffer contains the
    found filename string */
-int test_for_t1_file( char *buffer )
+static int test_for_t1_file( char *buffer )
 {
   int i=0;
   char *FullName;
@@ -704,9 +920,9 @@
 char *T1_GetFontFileName( int FontID)
 {
 
-  static char filename[T1_MAXPATHLEN+1];
+  static char filename[MAXPATHLEN+1];
   
-  if (CheckForInit())return(NULL);
+  if (T1_CheckForInit())return(NULL);
 
   /* Check first for valid FontID */
   if ((FontID<0) || (FontID>FontBase.no_fonts)){
@@ -733,7 +949,7 @@
 int T1_SetAfmFileName( int FontID, char *afm_name)
 {
 
-  if (CheckForFontID(FontID)!=0){
+  if (T1_CheckForFontID(FontID)!=0){
     /* Operation may not be applied because FontID is invalid
        or font is loaded */
     T1_errno=T1ERR_INVALID_FONTID;
@@ -767,9 +983,9 @@
 char *T1_GetAfmFileName( int FontID)
 {
 
-  static char filename[T1_MAXPATHLEN+1];
+  static char filename[MAXPATHLEN+1];
   
-  if (CheckForInit())return(NULL);
+  if (T1_CheckForInit())return(NULL);
 
   /* Check first for valid FontID */
   if ((FontID<0) || (FontID>FontBase.no_fonts)){
@@ -788,10 +1004,11 @@
 
 
   
-/* T1_Get_no_fonts(): Return the number of declared fonts */
-int  T1_Get_no_fonts(void)
+/* T1_GetNoFonts(): Return the number of declared fonts */
+int  T1_GetNoFonts(void)
 {
-  if (CheckForInit())return(-1);
+  if (T1_CheckForInit())
+    return(-1);
   return(FontBase.no_fonts);
 }
 
@@ -806,11 +1023,11 @@
 
   int i;
   
-  if (CheckForInit())
+  if (T1_CheckForInit())
     ;   /* Not initialized -> no size dependent data -> OK */
   else
     /* Check if size-dependent data is existent */
-    for ( i=T1_Get_no_fonts(); i; i--)
+    for ( i=T1_GetNoFonts(); i; i--)
       if (pFontBase->pFontArray[i-1].pFontSizeDeps!=NULL){
 	T1_errno=T1ERR_OP_NOT_PERMITTED;
 	return(-1); /* There's is size dependent data for a font */
@@ -862,7 +1079,7 @@
   
   
   /* Check for a valid source font */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(-1);
   }
@@ -1017,99 +1234,6 @@
 
 
 
-/* bin_dump(): Print a binary dump of a byte, short and
-   long variable (used for debug purposes only): */
-void bin_dump_c(unsigned char value, char space_flag)
-{
-  int i,j;
-  
-  for (i=0;i<=7;i++){
-    if ((j=((value)>>i)&0x01))
-      printf("X");
-    else
-      printf(".");
-  }
-  if (space_flag)
-    printf(" ");
-
-}
-
-void bin_dump_s(unsigned short value, char space_flag)
-{
-  int i,j;
-
-  if (T1_CheckEndian()){
-    for (i=8;i<=15;i++){
-      if ((j=((value)>>i)&0x01))
-	printf("X");
-      else
-	printf(".");
-    }
-    for (i=0;i<=7;i++){
-      if ((j=((value)>>i)&0x01))
-	printf("X");
-      else
-	printf(".");
-    }
-  }
-  else{
-    for (i=0;i<=15;i++){
-      if ((j=((value)>>i)&0x01))
-	printf("X");
-      else
-	printf(".");
-    }
-  }
-  if (space_flag)
-    printf(" ");
-  
-}
-
-void bin_dump_l(unsigned long value, char space_flag)
-{
-  int i,j;
-  
-  if (T1_CheckEndian()){
-    for (i=24;i<=31;i++){
-      if ((j=((value)>>i)&0x01))
-	printf("X");
-      else
-	printf(".");
-    }
-    for (i=16;i<=23;i++){
-      if ((j=((value)>>i)&0x01))
-	printf("X");
-      else
-	printf(".");
-    }
-    for (i=8;i<=15;i++){
-      if ((j=((value)>>i)&0x01))
-	printf("X");
-      else
-	printf(".");
-    }
-    for (i=0;i<=7;i++){
-      if ((j=((value)>>i)&0x01))
-	printf("X");
-      else
-	printf(".");
-    }
-  }
-  else{
-    for (i=0;i<=31;i++){
-      if ((j=((value)>>i)&0x01))
-	printf("X");
-      else
-	printf(".");
-    }
-  }
-  if (space_flag)
-    printf(" ");
-
-}
-
-
-
 /* CheckEndian(): Checks whether the current machine is of little or big
    endian architecture. This is important for concatenating bitmaps.
    Function returns 0 if LittleEndian and 1 if BigEndian representation
@@ -1163,11 +1287,11 @@
 char *T1_GetFontFilePath( int FontID)
 {
 
-  static char filepath[T1_MAXPATHLEN+1];
+  static char filepath[MAXPATHLEN+1];
   char *FileNamePath=NULL;
   
   /* is initialzed? */
-  if (CheckForInit()) {
+  if (T1_CheckForInit()) {
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
@@ -1202,13 +1326,13 @@
 char *T1_GetAfmFilePath( int FontID)
 {
   
-  static char filepath[T1_MAXPATHLEN+1];
+  static char filepath[MAXPATHLEN+1];
   char *FontFileName;
   char *AFMFilePath;
   int i, j;
   
   /* is initialized? */
-  if ((CheckForInit())) {
+  if ((T1_CheckForInit())) {
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
@@ -1261,13 +1385,16 @@
     filepath[i+4]='\0';
   }
   /* Get full path of the afm file (The case of a full path name
-     name specification is valid */
+     name specification is valid) */
   if ((AFMFilePath=intT1_Env_GetCompletePath( filepath, T1_AFM_ptr)) == NULL) {
     return NULL;
   }
+  
   strcpy( filepath, AFMFilePath);
   free( AFMFilePath);
   
   return( filepath);
   
 }
+
+
diff -Nru t1lib-grace/T1lib/t1lib/t1base.h t1lib-deb/T1lib/t1lib/t1base.h
--- t1lib-grace/T1lib/t1lib/t1base.h	2002-01-03 13:15:14.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1base.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1base.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-10-03
+  ----- Date:        2002-05-16
   ----- Description: This file is part of the t1-library. It contains
                      declarations and definitions for t1base.c
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2005.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -29,21 +29,18 @@
 
 void *T1_InitLib( int log);
 int intT1_scanFontDBase( char *filename);
+int intT1_scanFontDBaseXLFD( char *filename);
 int T1_CloseLib( void);
 int T1_AddFont( char *fontfilename);
 void T1_PrintLog( char *func_ident, char *msg_txt, int level, ...);
 void T1_SetLogLevel( int level);
-int CheckForInit(void);
-int CheckForFontID( int FontID);
-int test_for_t1_file( char *buffer );
+int T1_CheckForInit(void);
+int T1_CheckForFontID( int FontID);
 char *T1_GetFontFileName( int FontID);
-int  T1_Get_no_fonts(void);
+int  T1_GetNoFonts(void);
 int T1_SetDeviceResolutions( float x_res, float y_res);
 int T1_CopyFont( int FontID);
 int T1_QueryX11Support( void);
-void bin_dump_c(unsigned char value, char space_flag);
-void bin_dump_s(unsigned short value, char space_flag);
-void bin_dump_l(unsigned long value, char space_flag);
 int T1_CheckEndian(void);
 int T1_SetBitmapPad( int pad);
 int T1_GetBitmapPad( void);
@@ -53,6 +50,7 @@
 int T1_SetAfmFileName( int FontId, char *afm_name);
 char *T1_GetFontFilePath( int FontID);
 char *T1_GetAfmFilePath( int FontID);
+const char *T1_StrError( int t1err);
 
 extern int T1_Type1OperatorFlags;
 
@@ -60,21 +58,18 @@
 
 extern void *T1_InitLib( int log);
 extern int intT1_scanFontDBase( char *filename);
+extern int intT1_scanFontDBaseXLFD( char *filename);
 extern int T1_CloseLib( void);
 extern int T1_AddFont( char *fontfilename);
 extern void T1_PrintLog( char *func_ident, char *msg_txt, int level, ...);
 extern void T1_SetLogLevel( int level);
-extern int CheckForInit(void);
-extern int CheckForFontID( int FontID);
-extern int test_for_t1_file( char *buffer );
+extern int T1_CheckForInit(void);
+extern int T1_CheckForFontID( int FontID);
 extern char *T1_GetFontFileName( int FontID);
-extern int  T1_Get_no_fonts(void);
+extern int  T1_GetNoFonts(void);
 extern int T1_SetDeviceResolutions( float x_res, float y_res);
 extern int T1_QueryX11Support( void);
 extern int T1_CopyFont( int FontID);
-extern void bin_dump_c(unsigned char value, char space_flag);
-extern void bin_dump_s(unsigned short value, char space_flag);
-extern void bin_dump_l(unsigned long value, char space_flag);
 extern int T1_CheckEndian(void);
 extern int T1_SetBitmapPad( int pad);
 extern int T1_GetBitmapPad( void);
@@ -84,5 +79,6 @@
 extern int T1_SetAfmFileName( int FontId, char *afm_name);
 extern char *T1_GetFontFilePath( int FontID);
 extern char *T1_GetAfmFilePath( int FontID);
+extern const char *T1_StrError( int t1err);
 
 #endif
diff -Nru t1lib-grace/T1lib/t1lib/t1delete.c t1lib-deb/T1lib/t1lib/t1delete.c
--- t1lib-grace/T1lib/t1lib/t1delete.c	2002-01-03 13:15:14.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1delete.c	2007-12-23 07:49:42.000000000 -0800
@@ -1,11 +1,11 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1delete.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-06-03
+  ----- Date:        2002-12-02
   ----- Description: This file is part of the t1-library. It contains
                      functions for giving free previously allocated
 		     memory areas and similar things.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2002. 
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -76,7 +76,7 @@
   for ( j=0; j<4; j++){
     antialias=level[j];
     /* Check if size exists; if not, return 1 */
-    if ((ptr=QueryFontSize( FontID, size, antialias))!=NULL){
+    if ((ptr=T1int_QueryFontSize( FontID, size, antialias))!=NULL){
       /* We have to remove a size-> */
       jobs++;
       /* Get pointers to structure which is before/after  the structure
@@ -140,17 +140,17 @@
   
   FONTSIZEDEPS *ptr;
   
-  if (CheckForFontID(FontID)!=1)
+  if (T1_CheckForFontID(FontID)!=1)
     return(-1);
   
   /* Start deleting at the end of the linked list: */ 
   sizecount=0;
-  if ((ptr=GetLastFontSize( FontID))==NULL){
+  if ((ptr=T1int_GetLastFontSize( FontID))==NULL){
     /* There has not been any size dependent data: */
     return(0);
   }
 
-  while (((ptr=GetLastFontSize(FontID)) != NULL)){
+  while (((ptr=T1int_GetLastFontSize(FontID)) != NULL)){
     currsize=ptr->size;
     T1_DeleteSize( FontID, currsize);
     sizecount++;
@@ -198,12 +198,12 @@
   int result;
 
   
-  if (CheckForFontID(FontID)==-1){  /* Invalid ID */
+  if (T1_CheckForFontID(FontID)==-1){  /* Invalid ID */
     T1_errno=T1ERR_INVALID_FONTID;
     return(-1);   
   }
   
-  if (CheckForFontID(FontID)==0)   /* Font is not loaded */
+  if (T1_CheckForFontID(FontID)==0)   /* Font is not loaded */
     return(0);   
 
   /* Memory freeing must be done hierachical, start with size dependent
diff -Nru t1lib-grace/T1lib/t1lib/t1enc.c t1lib-deb/T1lib/t1lib/t1enc.c
--- t1lib-grace/T1lib/t1lib/t1enc.c	2002-07-29 13:37:48.000000000 -0700
+++ t1lib-deb/T1lib/t1lib/t1enc.c	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1enc.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-10-18
+  ----- Date:        2005-05-01
   ----- Description: This file is part of the t1-library. It contains
                      functions encoding handling at runtime.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001.
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2005.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -50,6 +50,7 @@
 #include "../type1/spaces.h"
 #include "../type1/util.h"
 #include "../type1/fontfcn.h"
+#include "../type1/paths.h"
 #include "../type1/regions.h"
 
 
@@ -424,7 +425,6 @@
   /* Check if exactly 256 characters have been defined, if not,
      return NULL: */
   if (charname_count!=256){
-    T1_errno=T1ERR_UNSPECIFIED;
     return( -1);
   }
 
@@ -534,7 +534,7 @@
   }
   
   if ( cnsize<0) {
-    /* T1_errno is already set from the respective function */
+    T1_errno=T1ERR_SCAN_ENCODING;
     if ( charnames!=NULL) {
       free(charnames); 
     }
@@ -629,7 +629,7 @@
   
   
   /* First, check for valid font ID residing in memory: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(-1);
   }
@@ -694,6 +694,7 @@
       }
     }
     /* Update kerning table */
+    pFontBase->pFontArray[FontID].KernMapSize=0;
     k=pFontBase->pFontArray[FontID].pAFMData->numOfPairs;
     if (k>0){ /* i.e., there are any pairs */
       /* OK, it does not suffice to alloc numOfPairs METRICS_ENTRYs, because
@@ -754,7 +755,7 @@
 int T1_SetDefaultEncoding( char **encoding)
 {
   
-  if (CheckForInit()){
+  if (T1_CheckForInit()){
     T1_errno=T1ERR_OP_NOT_PERMITTED;
     return(-1);
   }
@@ -772,7 +773,7 @@
   static char enc_scheme[256];
   
   /* First, check for valid font ID residing in memory: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   }
